interface FatcherOptions extends RequestInit {
    middlewares?: FatcherMiddleware[] | FatcherMiddleware[][];
}
interface FatcherRequest extends Request {
    options: Omit<FatcherOptions, 'middlewares'>;
}
interface FatcherResponse extends Response {
}
type FatcherMiddlewareNext = (request?: Partial<FatcherRequest>) => Promise<FatcherResponse> | FatcherResponse;
type FatcherMiddleware = (request: FatcherRequest, next: FatcherMiddlewareNext) => Promise<FatcherResponse> | FatcherResponse;
interface ExceptionOptions {
    validateCode?: (statusCode: number) => boolean;
}

declare function defineMiddleware(middleware: FatcherMiddleware): FatcherMiddleware;

declare const exception: (options?: ExceptionOptions) => FatcherMiddleware;

declare function fatcher(input: RequestInfo | URL, options?: FatcherOptions): Promise<FatcherResponse>;

interface Snapshot {
    request: FatcherRequest;
    response: FatcherResponse;
}
declare class FatcherError extends Error {
    constructor(request: FatcherRequest, response: FatcherResponse);
    name: string;
    snapshot: Snapshot;
}

declare function isFatcherError(error: unknown): error is FatcherError;

export { ExceptionOptions, FatcherError, FatcherMiddleware, FatcherMiddlewareNext, FatcherOptions, FatcherRequest, FatcherResponse, defineMiddleware, exception, fatcher, isFatcherError };
